// TimelineDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TimelineDemo.h"
#include "TimelineDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTimelineDemoDlg dialog

CString IntToHex(int i)
{
	CString s;
	s.Format(_T("%.8X"), i);
	return s;
}


CTimelineDemoDlg::CTimelineDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimelineDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimelineDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_ACTIVATION_PROTOCOL, edActivationProtocol);
	DDX_Control(pDX, IDC_EDIT_ACTIVATION_PROTOCOL_DESCRIPTION, edActivationProtocolDescription);
	DDX_Control(pDX, IDC_EDIT_ACTIVITY_ID, edActivityId);
	DDX_Control(pDX, IDC_STATIC_STATE, laState);
	DDX_Control(pDX, IDC_EDIT_DISPLAY_TEXT, edDisplayText);
	DDX_Control(pDX, IDC_EDIT_DESCIRPTION, edDescription);
	DDX_Control(pDX, IDC_STATIC_PROTOCOL, laProtocol);
	DDX_Control(pDX, IDC_EDIT_TITLE, edTitle);
}

BEGIN_MESSAGE_MAP(CTimelineDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_REGISTER_PROTOCOL, &CTimelineDemoDlg::OnBnClickedButtonRegisterProtocol)
	ON_BN_CLICKED(IDC_BUTTON_UNREGISTER_PROTOCOL, &CTimelineDemoDlg::OnBnClickedButtonUnregisterProtocol)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, &CTimelineDemoDlg::OnBnClickedButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &CTimelineDemoDlg::OnBnClickedButtonClose)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CREATE_ACTIVITY, &CTimelineDemoDlg::OnBnClickedButtonCreateActivity)
	ON_BN_CLICKED(IDC_BUTTON_BEGIN_SESSION, &CTimelineDemoDlg::OnBnClickedButtonBeginSession)
	ON_BN_CLICKED(IDC_BUTTON_DESTROY_ACTIVITY, &CTimelineDemoDlg::OnBnClickedButtonDestroyActivity)
	ON_BN_CLICKED(IDC_BUTTON_END_SESSION, &CTimelineDemoDlg::OnBnClickedButtonEndSession)
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()


// CTimelineDemoDlg message handlers

BOOL CTimelineDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	edActivationProtocol.SetWindowText(_T("uatest"));
	edActivationProtocolDescription.SetWindowText(_T("User Activity Test"));
	edActivityId.SetWindowText(_T("TestUserActivity"));
	laState.SetWindowText(_T("<No activity>"));
	laProtocol.SetWindowText(_T("<No activity>"));
	
	edDisplayText.SetWindowText(_T("Hello activities (Test)"));
	edDescription.SetWindowText(_T("Test User Activity"));
	
	FActivity = NULL;

	FShown = false;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimelineDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimelineDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTimelineDemoDlg::OnBnClickedButtonRegisterProtocol()
{
	// TODO: Add your control notification handler code here
	CString prot;
	edActivationProtocol.GetWindowText(prot);
	if (prot == _T(""))
		AfxMessageBox(_T("Activation protocol can not be an empty string"));
	else
	{
		CString desc;
		edActivationProtocolDescription.GetWindowText(desc);
		if (desc == _T(""))
			AfxMessageBox(_T("Protocol description can not be an empty string"));
		else
		{
			int Res = wclTimelineChannel.RegisterProtocol(tstring(prot), tstring(desc));
			if (Res != WCL_E_SUCCESS)
				AfxMessageBox(_T("Failed to register protocol: ") + IntToHex(Res));
			else
				AfxMessageBox(_T("Protocol registered"));
		}
	}
}

void CTimelineDemoDlg::OnBnClickedButtonUnregisterProtocol()
{
	CString prot;
	edActivationProtocol.GetWindowText(prot);
	if (prot == _T(""))
		AfxMessageBox(_T("Activation protocol can not be an empty string"));
	else
	{
		int Res = wclTimelineChannel.UnregisterProtocol(tstring(prot));
		if (Res != WCL_E_SUCCESS)
			AfxMessageBox(_T("Failed to unregister protocol: ") + IntToHex(Res));
		else
			AfxMessageBox(_T("Protocol unregistered"));
	}
}

void CTimelineDemoDlg::OnBnClickedButtonOpen()
{
	int Res = wclTimelineChannel.Open();
	if (Res != WCL_E_SUCCESS)
		AfxMessageBox(_T("Open channel failed: 0x") + IntToHex(Res));
	else
		AfxMessageBox(_T("Channel opened."));
}

void CTimelineDemoDlg::OnBnClickedButtonClose()
{
	DestroyActivity();
	
	int Res = wclTimelineChannel.Close();
	if (Res != WCL_E_SUCCESS)
		AfxMessageBox(_T("Close channel failed: 0x") + IntToHex(Res));
	else
		AfxMessageBox(_T("Channel closed."));
}

void CTimelineDemoDlg::OnDestroy()
{
	CDialog::OnDestroy();

	DestroyActivity();
	wclTimelineChannel.Close();
}

void CTimelineDemoDlg::OnBnClickedButtonCreateActivity()
{
	if (FActivity != NULL)
		AfxMessageBox(_T("Activity has already been created"));
	else
	{
		CString Id;
		edActivityId.GetWindowText(Id);
		int Res = wclTimelineChannel.CreateActivity(tstring(Id), FActivity);
		if (Res != WCL_E_SUCCESS)
			AfxMessageBox(_T("Create activity failed: 0x") + IntToHex(Res));
		else
		{
			AfxMessageBox(_T("Activity has been created"));
			
			switch (FActivity->State)
			{
				case asNew:
					{
						laState.SetWindowText(_T("New"));
						CString prot;
						edActivationProtocol.GetWindowText(prot);
						laProtocol.SetWindowText(prot);
					}
					break;

				case asPublished:
					laState.SetWindowText(_T("Published"));
					edDescription.SetWindowText(FActivity->Description.c_str());
					edDisplayText.SetWindowText(FActivity->DisplayText.c_str());
					laProtocol.SetWindowText(FActivity->Protocol.c_str());
					edTitle.SetWindowText(FActivity->Title.c_str());
					break;
			}
		}
	}
}

void CTimelineDemoDlg::OnBnClickedButtonBeginSession()
{
	if (FActivity == NULL)
		AfxMessageBox(_T("Activity has not been created"));
	else
	{
		if (FActivity->Active)
			AfxMessageBox(_T("Session is active"));
		else
		{
			CString a;
			edActivationProtocol.GetWindowText(a);
			FActivity->Protocol = tstring(a);
			// Add Activity ID as first parameter so we can open the
			// activity then. You can add additinal params if needed.
			FActivity->Params = FActivity->Id;
			edDescription.GetWindowText(a);
			FActivity->Description = tstring(a);
			edDisplayText.GetWindowText(a);
			FActivity->DisplayText = tstring(a);
			edTitle.GetWindowText(a);
			FActivity->Title = tstring(a);
			
			int Res = FActivity->BeginSession();
			if (Res != WCL_E_SUCCESS)
				AfxMessageBox(_T("Begin session failed: 0x") + IntToHex(Res));
			else
				AfxMessageBox(_T("Session has been started"));
		}
	}
}

void CTimelineDemoDlg::OnBnClickedButtonDestroyActivity()
{
	if (FActivity == NULL)
		AfxMessageBox(_T("Activity has not been created"));
	else
	{
		DestroyActivity();
		
		AfxMessageBox(_T("Activity released"));
	}
}

void CTimelineDemoDlg::OnBnClickedButtonEndSession()
{
	if (FActivity == NULL)
		AfxMessageBox(_T("Activity has not been created"));
	else
	{
		int Res = FActivity->EndSession();
		if (Res != WCL_E_SUCCESS)
			AfxMessageBox(_T("End session failed: 0x") + IntToHex(Res));
		else
			AfxMessageBox(_T("Session has been stopped"));
	}
}

void CTimelineDemoDlg::DestroyActivity()
{
	if (FActivity != NULL)
	{
		delete FActivity;
		FActivity = NULL;
		
		laState.SetWindowText(_T("<No activity>"));
		laProtocol.SetWindowText(_T("<No activity>"));
	}
}

void CTimelineDemoDlg::CheckParams()
{
	// Check application params.
	if (__argc > 1)
	{
		CString s(__targv[1]);
		tstring Str(s);
		// Make sure it is correct params.
		size_t p = Str.find(_T(":"));
		if (p != tstring::npos)
		{
			// Extract ActivityID.
			Str = Str.substr(p + 1, Str.length() - p - 1);
			// Start activity with given ID.
			if (Str != _T(""))
			{
				int Res = wclTimelineChannel.Open();
				if (Res == WCL_E_SUCCESS)
				{
					Res = wclTimelineChannel.CreateActivity(Str, FActivity);
					if (Res == WCL_E_SUCCESS)
					{
						AfxMessageBox(_T("Application started from Activity. Activity opened."));
						laState.SetWindowText(_T("Published"));
						edActivityId.SetWindowText(Str.c_str());
						edDescription.SetWindowText(FActivity->Description.c_str());
						edDisplayText.SetWindowText(FActivity->DisplayText.c_str());
						laProtocol.SetWindowText(FActivity->Protocol.c_str());
						edTitle.SetWindowText(FActivity->Title.c_str());
					}
					else
					{
						AfxMessageBox(_T("Create activity failed"));
						wclTimelineChannel.Close();
					}
				}
				else
					AfxMessageBox(_T("Channel open failed: 0x") + IntToHex(Res));
			}
		}
	}
}

void CTimelineDemoDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	// TODO: Add your message handler code here
	if (!FShown)
	{
		CheckParams();
		FShown = true;
	}
}